---
id: spark-runner
title: Spark runner
sidebar_label: Spark runner
---


The Spark runner uses [Apache Spark](https://spark.apache.org/) to execute workflows. It relies on the [RDD API](https://spark.apache.org/docs/latest/rdd-programming-guide.html), not the higher-level SQL API, for the following reasons:
- the SQL API puts some restrictions on the datatypes stored in cells, making it harder to store reconciliation data in cells directly;
- OpenRefine workflows heavily rely on expression languages, which would act as unanalyzable code blocks for the SQL engine, which would not be able to optimize SQL execution sufficiently
- many of OpenRefine's operations are not easy to translate to efficient SQL queries. For instance transpose operations or anything which relies on the records mode. The popularity of the tool is probably inherited from this different data model.

## Options

The following configuration parameters can be used with this runner:
|Configuration key|Default value|Description|
|---|---|---|
| `refine.runner.defaultParallelism` | `4` | how many partitions datasets should generally be split, unless they are very small or very big |
| `refine.runner.sparkMasterURI` | `local[4]` | a Spark URI, such as `spark://host:port` or `mesos://host:port`, to connect to an external Spark cluster for the execution of workflows. |

