package org.openrefine.model;

import java.io.IOException;
import java.util.Arrays;

import org.openrefine.util.ParsingUtilities;
import org.openrefine.util.TestUtils;
import org.testng.Assert;
import org.testng.annotations.Test;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;

public class IndexedRowTests {
    
    @Test
    public void saveIndexedRow() {
        Row row = new Row(Arrays.asList(new Cell("I'm not empty", null)));
        IndexedRow tuple = new IndexedRow(1234L, row);
        TestUtils.isSerializedTo(
                tuple,
                "{\"i\":1234,\"r\":{\"flagged\":false,\"starred\":false,\"cells\":[{\"v\":\"I'm not empty\"}]}}",
                ParsingUtilities.defaultWriter);
    }
    
    @Test
    public void readIndexedRow() throws JsonParseException, JsonMappingException, IOException {
        IndexedRow tuple = ParsingUtilities.mapper.readValue(
                "{\"i\":1234,\"r\":{\"flagged\":false,\"starred\":false,\"cells\":[{\"v\":\"I'm not empty\"}]}}",
                IndexedRow.class);
        Assert.assertEquals(tuple.getIndex(), 1234L);
    }
}
